
#include <stdbool.h>
#include <stdlib.h>
#include <stdio.h>

typedef struct _element {
    int data;
    struct _element *next;
} element;

typedef element *sorted_list;

bool sorted_list_empty(sorted_list l){
    return (l == NULL);
}


sorted_list sorted_list_push(sorted_list list, int val) {
    element *tmp = malloc(sizeof(*tmp));
    tmp->data = val;
    element *crt = list;
    while (NULL != crt->next && val > crt->next->data) {
        crt = crt->next;
    }
    tmp->next = crt->next;
    crt->next = tmp;
    return list;
}



sorted_list sorted_list_extract(sorted_list list, int val) {
    element *prec = list; // needed to glue elements together
    element *crt = list;
    while (NULL != crt && val > crt->data) {
        prec = crt;
        crt = crt->next;
    }
    if (NULL != crt && prec != crt && crt->data == val) { // si liste non finie & elem n'est pas le premier & elem est dans liste
        prec->next = crt->next;
        free(crt);
    }
    else if (NULL != crt && crt->data == val && prec == crt) { // si elem est le premier de la liste
        list = list->next;
        free(crt);
    }
    return list;
}

void sorted_list_print(sorted_list l){
    while (!sorted_list_empty(l)){
        printf("%d ", l->data);
        l = l->next;
    }
    printf("\n");
}

element* sorted_list_position(sorted_list list, int val){
    element *pos = list; // needed to glue elements together
    if (sorted_list_empty(list) || val <= list->data){
        return NULL;
    }
    else {
        while (NULL != pos->next && val > pos->next->data) {
            pos = pos->next;
        }
    }
    return pos;
}

element* sorted_list_search(sorted_list list, int val) {
    element *prec = list; // needed to glue elements together
    element *crt = list;
    while (NULL != crt && val > crt->data) {
        prec = crt;
        crt = crt->next;
    }
    element* pos = sorted_list_position(list, val);
    if (NULL == pos && val == list->data) {
        return list; // first element contains val
    } else if (NULL != pos && NULL != pos->next && val == pos->next->data) {
        return pos->next; // non-first element contains val
    } else {
        return NULL; // well... val's not here
    }
}



int main(){
    sorted_list list;
    sorted_list_push(list, 1);
    sorted_list_push(list, 2);
    sorted_list_push(list, 3);
    sorted_list_print(list);
    return 0;
}